<?php

namespace Drupal\taxonomy_bulk_actions\Plugin\TaxonomyBulkActions;

use Drupal\Core\Session\AccountProxyInterface;
use Drupal\taxonomy\TermInterface;
use Drupal\taxonomy_bulk_actions\TaxonomyBulkActionsManagerBase;
use Drupal\taxonomy_bulk_actions\Annotation\TaxonomyBulkActions;

/**
 * @TaxonomyBulkActions(
 *   id="taxonomy_bulk_action_delete",
 *   description="Delete selected terms"
 * )
 */
class TaxonomyBulkActionsDelete extends TaxonomyBulkActionsManagerBase {

  /**
   * {@inheritDoc}
   */
  public function access(AccountProxyInterface $account) {
    return $account->hasPermission('administer taxonomy');
  }

  /**
   * Implementation of action logic that should be executed on each selected term.
   *
   * @param TermInterface $term
   *   Term object that the action will be applied on.
   */
  public function execute(TermInterface $term) {
    $term->delete();
  }

  /**
   * {@inheritDoc}
   */
  public function actionFinishedMessage() {
    return $this->t('Deleting selected terms action has been finished');
  }
}
